import * as tslib_1 from "tslib";
import { CodeMirror as cm } from "@hpcc-js/codemirror-shim";
import { HTMLWidget } from "@hpcc-js/common";
import "codemirror/lib/codemirror.css";
import "../src/Editor.css";
var Editor = /** @class */ (function (_super) {
    tslib_1.__extends(Editor, _super);
    function Editor() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._initialText = "";
        return _this;
    }
    Editor.prototype.options = function () {
        return {
            lineNumbers: true,
            tabSize: 2
        };
    };
    Editor.prototype.text = function (_) {
        if (this._codemirror) {
            var doc = this._codemirror.getDoc();
            if (!arguments.length)
                return doc.getValue();
            doc.setValue(_);
            return this;
        }
        if (!arguments.length)
            return this._initialText;
        this._initialText = _;
        return this;
    };
    Editor.prototype.enter = function (domNode, element) {
        var _this = this;
        _super.prototype.enter.call(this, domNode, element);
        this._codemirror = cm.fromTextArea(element.append("textarea").node(), this.options());
        this._codemirror.on("changes", function (changes) {
            _this.changes(changes);
        });
        this.text(this._initialText);
    };
    Editor.prototype.update = function (domNode, Element) {
        _super.prototype.update.call(this, domNode, Element);
        this._codemirror.setSize(this.width() - 2, this.height() - 2);
        this._codemirror.refresh();
    };
    //  Events  ---
    Editor.prototype.changes = function (changes) {
    };
    return Editor;
}(HTMLWidget));
export { Editor };
Editor.prototype._class += " codemirror_Editor";
//# sourceMappingURL=Editor.js.map