(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "@hpcc-js/codemirror-shim", "@hpcc-js/common", "codemirror/lib/codemirror.css", "../src/Editor.css"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var codemirror_shim_1 = require("@hpcc-js/codemirror-shim");
    var common_1 = require("@hpcc-js/common");
    require("codemirror/lib/codemirror.css");
    require("../src/Editor.css");
    var Editor = /** @class */ (function (_super) {
        tslib_1.__extends(Editor, _super);
        function Editor() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._initialText = "";
            return _this;
        }
        Editor.prototype.options = function () {
            return {
                lineNumbers: true,
                tabSize: 2
            };
        };
        Editor.prototype.text = function (_) {
            if (this._codemirror) {
                var doc = this._codemirror.getDoc();
                if (!arguments.length)
                    return doc.getValue();
                doc.setValue(_);
                return this;
            }
            if (!arguments.length)
                return this._initialText;
            this._initialText = _;
            return this;
        };
        Editor.prototype.enter = function (domNode, element) {
            var _this = this;
            _super.prototype.enter.call(this, domNode, element);
            this._codemirror = codemirror_shim_1.CodeMirror.fromTextArea(element.append("textarea").node(), this.options());
            this._codemirror.on("changes", function (changes) {
                _this.changes(changes);
            });
            this.text(this._initialText);
        };
        Editor.prototype.update = function (domNode, Element) {
            _super.prototype.update.call(this, domNode, Element);
            this._codemirror.setSize(this.width() - 2, this.height() - 2);
            this._codemirror.refresh();
        };
        //  Events  ---
        Editor.prototype.changes = function (changes) {
        };
        return Editor;
    }(common_1.HTMLWidget));
    exports.Editor = Editor;
    Editor.prototype._class += " codemirror_Editor";
});
//# sourceMappingURL=Editor.js.map